local progress = 0

local smallerFont = love.graphics.newFont(14)

local messages = {
{"Gravitate",0,10,1,largeFont}, --Text, X, Y, Wrap (percent), font
{"Made using the LÖVE framework",0,150,1},
{"love2d.org",0,165,1,smallFont},
{"Lead Programmer",0,730,0.5},
{"Lead Designer",400,730,0.5},
{"Mickeyjm",0,750,0.5,smallerFont},
{"Mickeyjm",400,750,0.5,smallerFont},
{"Box2D Physics adapter",0,780,0.5},
{"Level Designer",400,780,0.5},
{"Mickeyjm",0,800,0.5,smallerFont},
{"Mickeyjm",400,800,0.5,smallerFont},
{"Programmer of assorted stuff",0,830,0.5},
{"Original Concept",400,830,0.5},
{"Mickeyjm",0,850,0.5,smallerFont},
{"Mickeyjm",400,850,0.5,smallerFont},
{"Lead Procrastinator",0,880,0.5},
{"\"Artist\"",400,880,0.5},
{"Mickeyjm",0,900,0.5,smallerFont},
{"Mickeyjm",400,900,0.5,smallerFont},
{"Assistant Procrastinator",0,930,0.5},
{"Credits writer",400,930,0.5},
{"Mickeyjm",0,950,0.5,smallerFont},
{"Mickeyjm",400,950,0.5,smallerFont},
{"Trainee Procrastinator",0,980,0.5},
{"Display writer",400,980,0.5},
{"Mickeyjm",0,1000,0.5,smallerFont},
{"Mickeyjm",400,1000,0.5,smallerFont},
{"Creator of credit roles",0,1030,0.5},
{"Map format inventor",400,1030,0.5},
{"Mickeyjm",0,1050,0.5,smallerFont},
{"Mickeyjm",400,1050,0.5,smallerFont},
{"Consumer of biscuits",0,1080,0.5},
{"Corner cutter",400,1080,0.5},
{"Mickeyjm",0,1100,0.5,smallerFont},
{"Mickeyjm",400,1100,0.5,smallerFont},
{"Bug fixer",0,1130,0.5},
{"Bug implementer",400,1130,0.5},
{"Mickeyjm",0,1150,0.5,smallerFont},
{"Mickeyjm",400,1150,0.5,smallerFont},
{"Alpha tester",0,1180,0.5},
{"Beta tester",400,1180,0.5},
{"Mickeyjm",0,1200,0.5,smallerFont},
{"Mickeyjm",400,1200,0.5,smallerFont},
{"Code monkeys",0,1230,0.5},
{"Code monkey handlers",400,1230,0.5},
{"Mickeyjm",0,1250,0.5,smallerFont},
{"Mickeyjm",400,1250,0.5,smallerFont},
{"Mickeyjm",0,1270,0.5,smallerFont},
{"Mickeyjm",400,1270,0.5,smallerFont},
{"Mickeyjm",0,1290,0.5,smallerFont},
{"Mickeyjm",400,1290,0.5,smallerFont},
{"Translator (English>English)",0,1320,0.5},
{"Lead overseer of of lead procrastinator",400,1320,0.5},
{"Mickeyjm",0,1340,0.5,smallerFont},
{"Mickeyjm",400,1340,0.5,smallerFont},
{"Scriber of TODO list",0,1370,0.5},
{"Generator of changelog",400,1370,0.5},
{"Mickeyjm",0,1390,0.5,smallerFont},
{"Mickeyjm",400,1390,0.5,smallerFont},
{"Thank you for playing Gravitate",0,1750,1},
}

local startDelay = 2
local endDelay = 2
local pauseAt = 1450

function drawCredits()
	love.graphics.setBackgroundColor(100,0,0)
	for i=1,#messages do
		local m = messages[i]
		if m[5] then
			love.graphics.setFont(m[5])
		end
		love.graphics.printf(m[1],m[2],m[3]-progress,love.graphics.getWidth()*m[4],"center")
		love.graphics.setFont(normalFont)
	end
end

function updateCredits(dt)
	if startDelay>0 then
		startDelay = startDelay - dt
	else
		if progress>pauseAt and endDelay>0 then
			endDelay = endDelay-dt
		elseif endDelay>0 then
			progress = progress+dt*60
		else
			startDelay = 2
			endDelay = 2
			progress = 0
			state = "title"
		end
		if love.keyboard.isDown("escape") or progress>messages[#messages][3]+400 then
			startDelay = 2
			endDelay = 2
			progress = 0
			state = "title"
		end
	end
end