--===============================================Requires
res = require"resolution"
phyz = require"phyzHook"
binds = require"keyBinder"
require"renderWorld"
require"mapLoader"
require"player"
require"title"
require"options"
require"credits"
--===============================================Variables

map = {} --The loaded level

state = "title" --The game state

--===============================================Set up window
local icon = love.graphics.newImage("assets/icon.png")
love.graphics.setCaption("Gravitate")
love.graphics.setIcon(icon)
--===============================================Testing

--All testing material has been moved to a test level file

--===============================================Callbacks
function love.load(t)
end

function love.draw()
	res:draw() --Letter box it all
	if state == "title" then
		drawTitle()
	elseif state == "options" then
		drawOptions()
	elseif state == "credits" then
		drawCredits()
	elseif state == "level" then
		drawLevel()
	end
	res:undraw() -- Stop love.run breaking
end


function love.keypressed(k,u)
	--Temporary
	if k==binds.getKey("Fields") and state == "level" then
		DRAW_FIELDS = not DRAW_FIELDS
	end
	if k=="escape" and state == "title" then
		love.event.quit()
	end
	if state == "options" then
		keyPressedOptions(k,u)
	end
end

function love.update(dt)
	if state == "title" then
		updateTitle(dt)
	elseif state == "level" then
		playerUpdate(dt)
		map.world:update(dt)
	elseif state == "options" then
		updateOptions(dt)
	elseif state == "credits" then
		updateCredits(dt)
	end
end

function love.mousepressed(x,y,b)
	x,y = love.mouse.getPosition() -- Allows resolution.lua to sort out positions
	if state == "title" then
		mousePressedTitle(x,y,b)
	end
	if state == "options" then
		mousePressedOptions(x,y,b)
	end
end