local SPEED = 500
local JUMP = 100

local tan,sqrt,pi = math.tan,math.sqrt,math.pi

binds.bind("up","jump")
binds.bind("left","left")
binds.bind("right","right")
binds.bind("down","fall")

function playerUpdate(dt)
	local angle = map.player.body:getAngle()
	if map.player.onGround then
		if binds.isPressed("jump") then
			--Calculate ratios of jump
			local x = tan(angle)
			--Scale ratios to correct size
			local hyp = sqrt(x^2+1)
			local velx = x/(hyp/JUMP)
			local vely = 1/(hyp/JUMP)
			--Apply force
			if angle<3*pi/2 and angle>pi/2 then
				map.player.body:applyLinearImpulse(-velx,vely)
			else
				map.player.body:applyLinearImpulse(velx,-vely)
			end
		end
		SPEED = 1000 --Counter friction
	else
		SPEED = 500
	end
	if binds.isPressed("jump") and map.player.inVoid then
		--Calculate ratios of jump
		local x = tan(angle)
		--Scale ratios to correct size
		local hyp = sqrt(x^2+1)
		local velx = x/(hyp/SPEED)
		local vely = 1/(hyp/SPEED)
		--Apply force
		if angle<3*pi/2 and angle>pi/2 then
			map.player.body:applyForce(-velx,vely)
		else
			map.player.body:applyForce(velx,-vely)
		end
	end
	if binds.isPressed("fall") then
		--Calculate ratios of jump
		local x = tan(angle)
		--Scale ratios to correct size
		local hyp = sqrt(x^2+1)
		local velx = x/(hyp/SPEED)
		local vely = 1/(hyp/SPEED)
		--Apply force
		if angle<3*pi/2 and angle>pi/2 then
			map.player.body:applyForce(velx,-vely)
		else
			map.player.body:applyForce(-velx,vely)
		end
	end
	if binds.isPressed("left") then
		--Calculate ratios of movement
		local x = tan(pi/2-angle)
		--Scale ratios to correct size
		local hyp = sqrt(x^2+1)
		local velx = x/(hyp/SPEED)
		local vely = 1/(hyp/SPEED)
		--Apply force
		if angle>=pi or angle<0 then
			map.player.body:applyForce(velx,vely)
		else
			map.player.body:applyForce(-velx,-vely)
		end
	end
	if binds.isPressed("right") then
		--Calculate ratios of movement
		local x = tan(pi/2-angle)
		--Scale ratios to correct size
		local hyp = sqrt(x^2+1)
		local velx = x/(hyp/SPEED)
		local vely = 1/(hyp/SPEED)
		--Apply force
		if angle>pi or angle<0 then
			map.player.body:applyForce(-velx,-vely)
		else
			map.player.body:applyForce(velx,vely)
		end
	end
end
